﻿# The script of the game goes in this file.

# Declare characters used by this game. The color argument colorizes the
# name of the character.

define sergej = Character("Sergej",who_color="#b7b7b7")
define helwig = Character("Helwig",who_color="#8e8768")
define stefan = Character("Stefan",who_color="#4e6382")
define noeska = Character("Noeska",who_color="#737373")
define veronika = Character("Veronika",who_color="#695543")
define meister = Character("Meister",who_color="#989c9e")
define jan = Character("Jan",who_color="#816d23")

define juraj = Character("Juraj",who_color="#ed5615")
define fabian = Character("Fabian",who_color="#732424")
define eric = Character("Eric",who_color="#6d6d6d")
define chaoran = Character("Chaoran",who_color="#a8a8a8")
define sherin = Character("Sherin",who_color="#3c5c81")
define laura = Character("Laura",who_color="#700300")
define fourough = Character("Fourough",who_color="#f94f6b")
define thomas = Character("Thomas",who_color="#b0cdff")
define yngve = Character("Yngve",who_color="#48361b")

define finaltext = Character(None,
                      what_size=48, #Font size
                      what_xalign=0.5, #Centers text within the window
                      window_xalign=0.5, #Centers the window horizontally
                      window_yalign=0.5, #Centers the window vertically
                      what_text_align=0.5, #Centers text within the window, just in case
                      #window_background=None,#Removes the window, so only the text shows
                      what_outlines=[(3, "#000000", 2, 2), (3, "#282", 0, 0)],
                      #Gives an outline
                      what_slow_cps=20 #Speed at which the text appears (slow)
                    )

# State variables
default storage_room_discovered = False
default coffee_machine_discovered = False
default meister_discovered = False
default meister_called = False
default server_room_discovered = False

default juraj_revealed = False
default fabian_revealed = False
default eric_revealed = False
default chaoran_revealed = False
default sherin_revealed = False
default laura_revealed = False
default fourough_revealed = False
default thomas_revealed = False
default yngve_revealed = False

default floppy_year = 0
default veronika_talked = False
default disk_obtained = False
default source_obtained = False
default source_correct = False

default correct_load = False
default program_load = False
default failure_count = 0
default called_jan = False

# The game starts here.

label start:



    # Show a background. This uses a placeholder by default, but you can
    # add a file (named either "bg room.png" or "bg room.jpg") to the
    # images directory to show it.

    scene bg entrace

    # This shows a character sprite. A placeholder is used, but you can
    # replace it by adding a file named "eileen happy.png" to the images
    # directory.

    show sergej

    # These display lines of dialogue.

    play sound "audio/sergej-hi.mp3"

    sergej "Hi there, I'm Sergej. You must be the new PhD student."

    sergej "It's good that you're here. We're in a bit of a dilemma."

    sergej "Every year, we send out an interactive Christmas card."

    sergej "But every time it's a bit of a struggle to get it done in time."

    queue sound "audio/sergej-default.mp3"

    sergej "You'd be doing me a great favor by helping with the remaining TODOs the professors left me with."

    sergej "Stefan's students were working on the source code, so you'll have to ask him about it."

    sergej "Additionally, you need to collect the list of email addresses from Helwig."

    sergej "And finally, you need to send out the cards. I think Noeska knows the password to the server."

    sergej "Is everything clear? Great! Please hurry, there is not much time left."

    sergej "If you have any questions, you should probably check our website at https://vis.uib.no"

menu main_navigation:

    "Where do you want to go?"

    "Go to Helwig's office.":
        jump office_helwig

    "Go to Stefan's office.":
        jump office_stefan

    "Go to Noeska's office.":
        jump office_noeska

    "Go to storage room." if storage_room_discovered:
        jump storage_room

    "Go to coffee machine." if coffee_machine_discovered:
        jump coffee_machine

    "Call Meister" if meister_discovered:
        jump skype_meister

    "Go to server room" if server_room_discovered:
        jump server_room

label office_helwig:

    scene bg helwig

    if storage_room_discovered:
        "It seems that Helwig is in a meeting right now, better not interrupt him."
        jump main_navigation

    show helwig

    play sound "audio/helwig-hi.mp3"

    helwig "Oh hi, I suppose you are the new PhD student."

    helwig "What can you do for me?"

    queue sound "audio/helwig-default.mp3"

    default menuset_helwig1 = set()

    menu menu_helwig1:

        set menuset_helwig1

        "I need the latest source code for the Christmas card.":
            helwig "Sorry, I can't help you with that!"
            jump menu_helwig1

        "I'm here to collect the e-mail addresses for the Christmas card.":
            helwig "Great! All the new ones are already entered into the mail merge script, but the remaining ones are on a floppy disk in the storage room."
            $ storage_room_discovered = True

        "Can you tell me the password for the mail server?":
            helwig "Hmm, I'm not sure. It may be 'yrkvk783&UmkluImp'."
            jump menu_helwig1

label aftermenu_helwig1:

    default menuset_helwig2 = set()

    menu menu_helwig2:

        set menuset_helwig2

        "Floppy disk? It's 2019!":
            helwig "We had to include something to justify the 8-bit aesthetic, so just roll with it."
            jump menu_helwig2

        "How am I going to access them?":
            helwig "There's an old C64 in the server room that's hooked up to our network using some magic gadget. Just run the first program on the disk, and everything else will happen automatically."
            jump menu_helwig2

label aftermenu_helwig2:

    queue sound "audio/helwig-default.mp3"

    helwig "I've been curating this list forever."

    helwig "I think it's filed together with some of the other things from the year of my dissertation."

    helwig "Sorry, but I have a meeting now. See you later!"

    hide helwig with moveoutright

    jump main_navigation

label office_stefan:

    scene bg stefan

    if coffee_machine_discovered:
        "Stefan's office is locked."
        jump main_navigation

    show stefan

    play sound "audio/stefan-hi.mp3"

    stefan "Welcome! I suppose you are the new PhD student."

    stefan "Thanks for volunteering to take care of the Christmas card."

    menu:
        "Well, I didn't exactly volunteer ...":
            stefan "Thank you for volunteering!"

        "No problem.":
            stefan "Great!"

    queue sound "audio/stefan-default.mp3"
    stefan "Is there anything you need?"

    default menuset_stefan1 = set()

    menu menu_stefan1:

        set menuset_stefan1

        "What's up with the hair?":
            stefan "What do you mean?"
            jump menu_stefan1

        "It's December and we're in Norway, why in the world are you wearing sunglasses?":
            stefan "I have no idea what you're talking about."
            jump menu_stefan1

        "I was told that I can get the latest source code for the Christmas card from you?":
            stefan "Several people were working on this, but I believe one of my PhD students should have the latest version."
            $ coffee_machine_discovered = True
            jump menu_stefan1

label aftermenu_stefan1:

    stefan "You should find most of the PhD students hanging around the coffee machine."
    stefan "I have to run now, but I trust that you'll take care of the remaining Christmas card issues."

    hide stefan with moveoutleft

    jump main_navigation

label office_noeska:

    scene bg noeska

    if server_room_discovered == True:
        "Noeska has left for the day."
        jump main_navigation

    show noeska

    play sound "audio/noeska-hi.mp3"

    noeska "Hello! You're the new PhD student, right?"
    noeska "Thanks for helping out with the Christmas card."

    if storage_room_discovered == False and coffee_machine_discovered == False:
        noeska "You should probably first see Stefan about the code and ask Helwig about the email list."
        noeska "Once you have done that, come back here and we'll discuss what else needs to be done."
        jump main_navigation
    elif coffee_machine_discovered == False:
        noeska "Before anything else can be done, you need to make sure that you have the latest source code for the card."
        jump main_navigation
    elif storage_room_discovered == False:
        noeska "Without Helwig's list of email addresses, we can't possibly send out the card."
        jump main_navigation

    queue sound "audio/noeska-default.mp3"

    noeska "Everything else has been set up, you just need to go to the server room and send out the emails."

    noeska "The password is ... uhm ..."

    noeska "What was it again? Hmmm ..."

    noeska "To be honest, I forgot. If only I had something to remind me."

    noeska "It was the first word from one of our recent publications in 2019."

    noeska "And it had something to do with time ... and remembering."

    noeska "I have to leave now, but I'm sure you'll figure it out!"

    $ server_room_discovered = True

    hide noeska with moveoutleft

    jump main_navigation

label storage_room:

    scene bg veronika

    if disk_obtained == True:
        "Veronika isn't here at the moment. Better not touch anything."
        jump main_navigation

    play sound "audio/veronika-hi.mp3"

    show veronika

    if veronika_talked == False:

        veronika "Who are you and what are you doing in my office?"

        menu:
            "Office? I thought this was the storage room.":
                queue sound "audio/veronika-default.mp3"
                veronika "Well as an adjunct I'm not here every day, so people keep putting stuff here."
                veronika "What do you need?"
                "I am looking for a floppy disk."
                veronika "There are a bunch of old disks back there in the drawer."
                veronika "They are sorted according to years."
                veronika "Which year do you want?"
                $veronika_talked = True

            "Sorry, wrong room.":
                veronika "No problem."
                jump main_navigation
    else:

        veronika "So, did you find out which disk you want?"

label input_floppy_year:

        menu:

            "1994":
                $floppy_year = 1994

            "1995":
                $floppy_year = 1995

            "1996":
                $floppy_year = 1996

            "1997":
                $floppy_year = 1997

            "1998":
                $floppy_year = 1998

            "1999":
                $floppy_year = 1999

            "2000":
                $floppy_year = 2000

            "2001":
                $floppy_year = 2001

#virtual keyboard support on mobile is missing
#        $ floppy_year = renpy.input("Which year do you need?", "", allow="0123456789")

#        python:
#            try:
#                floppy_year = int(floppy_year)
#            except ValueError:
#                floppy_year = 0

#        if floppy_year < 1990 or floppy_year > 2000:
#            veronika "Sorry, but there is no disk from that year."
#            jump input_floppy_year

        menu:
            "Are you sure?"

            "Yes, that's the one.":
                veronika "Here you go."
                $disk_obtained = True

            "Uhm, maybe not.":
                jump input_floppy_year

            "I'll come back later.":
                veronika "Ok, I'll be here for a bit longer."
                jump main_navigation

        veronika "See you around."

        hide veronika with moveoutright

        jump main_navigation

label coffee_machine:

    scene bg coffee

    if source_obtained == True:
        "All the other PhD students have already left for Christmas. You're standing in front of the coffee machine sad and alone."
        jump main_navigation

    show juraj

    play sound "audio/juraj-hi.mp3"
    juraj "Hi, I'm Juraj. Can I help you?"

    default menuset_juraj = set()

    menu menu_juraj:

        set menuset_juraj

        "I am looking for someone with the latest source code for the Christmas card.":
            queue sound "audio/juraj-default.mp3"
            juraj "Hmm ... I worked on it for a bit, but I definitely know that Chaoran and Fourough made some changes after me, so you should ask them."
            jump menu_phd

        "Do you know what year Helwig finished his PhD?":
            queue sound "audio/juraj-default.mp3"
            juraj "I have no idea, but you can call Meister Edi Gröller who was his PhD advisor."
            $meister_discovered = True
            jump menu_juraj


    $ chaoran_revealed = True
    $ fourough_revealed = True

    menu menu_phd:

        "Talk to Chaoran":
            show chaoran at left with moveinleft
            play sound "audio/chaoran-hi.mp3"
            "Hi, do you have the latest source code for the Christmas card?"
            queue sound "audio/chaoran-default.mp3"
            chaoran "My version is not the latest, I know that one of the girls was working on it after me."
            hide chaoran with moveoutleft
            $ laura_revealed = True
            $ fourough_revealed = True
            jump menu_phd

        "Talk to Fourough" if fourough_revealed:
            show fourough at left with moveinleft
            play sound "audio/fourough-hi.mp3"
            "Hi, I'm looking for the latest source code for the Christmas card."
            queue sound "audio/fourough-default.mp3"
            fourough "I was working on it, but Fabian, Eric, and Thomas fixed some bugs after me."
            hide fourough with moveoutleft
            $ fabian_revealed = True
            $ eric_revealed = True
            $ thomas_revealed = True
            jump menu_phd

        "Talk to Laura" if laura_revealed:
            show laura at left with moveinleft
            play sound "audio/laura-hi.mp3"
            "I was told you may have the most recent source code for the Christmas card."
            queue sound "audio/laura-default.mp3"
            laura "I was working on some of the images a few days ago, but I'm pretty sure I saw Yngve making major changes yesterday."
            hide laura with moveoutleft
            $yngve_revealed = True
            jump menu_phd

        "Talk to Fabian" if fabian_revealed:
            show fabian at left with moveinleft
            play sound "audio/fabian-hi.mp3"
            "Do you have the most recent source code for the Christmas card?"
            queue sound "audio/fabian-default.mp3"
            fabian "I'm not sure, but I definitely have a later version than Sherin and Thomas."
            hide fabian with moveoutleft
            $sherin_revealed = True
            $thomas_revealed = True
            jump menu_phd


        "Talk to Eric" if eric_revealed:
            show eric at left with moveinleft
            play sound "audio/eric-hi.mp3"
            "Hi, do you have the latest source code for the Christmas card?"
            queue sound "audio/eric-default.mp3"
            eric "I made my last changes yesterday, and I know that Thomas fixed a bug after me."
            hide eric with moveoutleft
            jump menu_phd

        "Talk to Thomas" if thomas_revealed:
            show thomas at left with moveinleft
            play sound "audio/thomas-hi.mp3"
            "I was wondering whether you have the latest source code for the Christmas card."
            queue sound "audio/thomas-default.mp3"
            thomas "I fixed a small bug yesterday at 11pm, but nothing after that."
            hide thomas with moveoutleft
            jump menu_phd

        "Talk to Yngve" if yngve_revealed:
            show yngve at left with moveinleft
            play sound "audio/yngve-hi.mp3"
            "Hi Yngve, Laura said you worked on the Christmas card yesterday. Do you have the latest version?"
            queue sound "audio/yngve-default.mp3"
            yngve "Yes, I worked on it until yesterday, but I'm really not sure whether someone modified the code after me."
            hide yngve with moveoutleft
            jump menu_phd

        "Talk to Sherin" if sherin_revealed:
            show sherin at left with moveinleft
            play sound "audio/sherin-hi.mp3"
            "Do you know who has the latest source code for the Christmas card?"
            queue sound "audio/sherin-default.mp3"
            sherin "I don't know who it was, but I know that some changes were made earlier today. Maybe you should ask Fabian."
            hide sherin with moveoutleft
            $fabian_revealed = True
            jump menu_phd

        "Obtain source code":
            jump after_menu_phd

label after_menu_phd:

    menu menu_code:
        "Who's source code do you want to use?"

        "Chaoran":
            $source_obtained = True
            $source_correct = False

        "Fourough":
            $source_obtained = True
            $source_correct = False

        "Laura":
            $source_obtained = True
            $source_correct = False

        "Fabian":
            $source_obtained = True
            $source_correct = True

        "Eric":
            $source_obtained = True
            $source_correct = False

        "Thomas":
            $source_obtained = True
            $source_correct = False

        "Yngve":
            $source_obtained = True
            $source_correct = False

        "Sherin":
            $source_obtained = True
            $source_correct = False

        "Go back and talk to them again":
            jump menu_phd

    hide juraj with moveoutright
    jump main_navigation

label skype_meister:

    show bg monitor

    if meister_called == True:
        "He does not seem to pick up."
        jump main_navigation

    play sound "audio/skype.mp3"

    show meister with dissolve
    queue sound "audio/meister-hi.mp3"

    meister "Hello. Who are you?"
    "Hi, I'm a new PhD student from Bergen. I just wanted to ask you when Helwig received his PhD."

    queue sound "audio/meister-default.mp3"
    meister "That was a long time ago. Let me think. It must have been in a time when long hair was still fashionable."
    "Uh..."
    meister "It must have been 1998 or 1988, I'm just not sure anymore."
    "Ok, thank you."
    $meister_called = True

    hide meister with dissolve

    jump main_navigation

label skype_brno:

    jump main_navigation

label server_room:

    show bg serverroom

    if disk_obtained == False and source_obtained == False:
        "You should get the disk with the email addresses and the source code for the card before going there."
        jump main_navigation
    elif source_obtained == False:
        "You should get the source code for the card before going there."
        jump main_navigation
    elif disk_obtained == False:
        "You should get the disk with the email addresses before going there."
        jump main_navigation

    "The server room looks like from the last century."
    "In the corner, there is a Commodore 64 with a 1541 floppy drive. It's a perfect match for the disk you have."
    "There is a post-it note on the desk that says 'set up by Jan'. This must be Jan Byska, who recently moved back to Brno."
    "You turn on the computer and insert the disk into the drive. If only you remembered how to load a program."

    show bg c64

    menu menu_c64:
        "What do you want to type?"


        "LOAD \"$\",8,1":
            queue sound "audio/c64.mp3"
            "SEARCHING FOR $\nLOADING\nREADY."
            $program_load = True
            $correct_load = False
            $failure_count +=  1
            jump menu_c64

        "LOAD \"#\",8":
            queue sound "audio/c64.mp3"
            "SEARCHING FOR #\nLOADING\nREADY."
            $program_load = True
            $correct_load = False
            $failure_count +=  1
            jump menu_c64

        "LOAD \"*\",8,1":
            queue sound "audio/c64.mp3"
            "SEARCHING FOR *\nLOADING\nREADY."
            $program_load = True
            $correct_load = True
            jump menu_c64

        "EXEC \"*\",8":
            "?SYNTAX ERROR\nREADY."
            $failure_count +=  1
            jump menu_c64

        "RUN":
            if program_load == True and correct_load == True:
                jump after_menu_c64
            elif program_load == True:
                "READY."
                $failure_count +=  1
            else:
                "?OUT OF DATA ERROR\nREADY."
                $failure_count +=  1
            jump menu_c64

        "Call Jan for help" if failure_count > 5 and called_jan == False:
            show bg monitor
            play sound "audio/skype.mp3"

            show jan with dissolve
            queue sound "audio/jan-hi.mp3"
            jan "Hello. Who is this?"
            "Hi, I'm a new PhD student from Bergen and I'm having problems importing the Christmas card addresses from the floppy disk."
            queue sound "audio/jan-default.mp3"
            jan "That's easy. You first need to load the program into memory using LOAD \"*\",8,1."
            jan "Then, you just have to execute it by entering RUN."
            jan "Everything else happens automatically."
            "Thanks a lot!"
            $called_jan = True
            hide jan with dissolve
            show bg c64
            jump menu_c64

label after_menu_c64:

    show bg serverroom

    "It seems that it worked. One of the other computers in the room suddenly prompts you for a password. This must be the mail sever. Now what was that password again?"

    $ count = 3

    while count > 0:
# virtual keyboard not working on mobile platforms
        menu:
            "yrkvk783&UmkluImp":
                $password = "yrkvk783&UmkluImp"
            "Scale-Space":
                $password = "Scale-Space"
            "Towards":
                $password = "Towards"
            "SpectraMosaic":
                $password = "SpectraMosaic"
            "Memento":
                $password = "Memento"
            "EvalViz":
                $password = "EvalViz"
            "LinesLab":
                $password = "LinesLab"
            "Personalized":
                $password = "Personalized"
#        $ password = renpy.input("Enter password:", "", "")

        if password.lower() == "memento":
            jump password_correct

        $ count -= 1
        "Password incorrect, [count] attempts remaining."

    jump password_incorrect

label password_correct:
    "The password was correct. The card has been sent out in the last minute. Hurra!"

    if source_correct == True:
        "The latest version of the source code works perfectly."

        if floppy_year == 1998:
            "Everybody in the community will be very impressed by how much time the folks in Bergen have to spend on this kind of stuff."
            "It will be a great Christmas for everyone and a good start for your PhD studies."
        else:
            "Unfortunately, the disk only contained email addresses from egyptologists who didn't care about the card at all."
            "Many people in the community are disappointed not to receive a Christmas card from Bergen this year."
            "This is not a good start for your PhD studies."
    else:
        "Unfortunately the version of the card you sent contained a major bug that crashes everyone's computer."

        if floppy_year == 1998:
            "Since the card went to many important people in the community, dire consequences can be expected."
            "What a horrible start for your PhD studies."
        else:
            "At least you used the wrong disk, so the card was mostly received by egyptologists."
            "Still, not an ideal start for your PhD studies."

    jump end

label password_incorrect:
    "After entering the incorrect password, the server has locked itself."
    "IT services have already left for the holidays, so there is no way to recover it in time."
    "It seems there will be no Christmas (card) this year."
    "Many people in the community will be disappointed."
    "This is certainly not a great start for your PhD studies."
    jump end

label end:

    window hide
    play music "audio/8BitJingleBells.mp3"
    scene bg final
    $ renpy.pause(60.0)
    finaltext "We hope you had a bit of fun with our little game."
    finaltext "Best wishes from Bergen!"
    finaltext "- THE END -"
    $ renpy.pause(120.0)
    # This ends the game.

    return
